Loading...
Searching...
No Matches
openshot::Sharpen Class Reference

This class provides a sharpen effect for video frames. More...

`#include <effects/Sharpen.h>`

Inheritance diagram for openshot::Sharpen:

## Public Member Functions

std::shared_ptr< Frame > | GetFrame (int64_t n) override
| This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.
std::shared_ptr< Frame > | GetFrame (std::shared_ptr< Frame > frame, int64_t frame_number) override
| This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.
std::string | Json () const override
| Get and Set JSON methods.
Json::Value | JsonValue () const override
| Generate Json::Value for this object.
std::string | PropertiesJSON (int64_t requested_frame) const override
void | SetJson (const std::string value) override
| Load JSON string into this object.
void | SetJsonValue (const Json::Value root) override
| Load Json::Value into this object.
| Sharpen ()
| Default constructor.
| Sharpen (Keyframe new_amount, Keyframe new_radius, Keyframe new_threshold)
| Constructor with initial values.
Public Member Functions inherited from openshot::EffectBase
Json::Value | BasePropertiesJSON (int64_t requested_frame) const
| Generate JSON object of base properties (recommended to be used by all effects).
int | constrain (int color_value)
| Constrain a color value from 0 to 255.
void | DisplayInfo (std::ostream *out=&std::cout)
| Display effect information in the standard output stream (stdout).
virtual std::string | GetVisibleObjects (int64_t frame_number) const
| Get the indexes and IDs of all visible objects in the given frame.
void | InitEffectInfo ()
virtual std::string | Json (int64_t requested_frame) const
Json::Value | JsonInfo () const
| Generate JSON object of meta data / info.
int | Order () const
| Get the order that this effect should be executed.
void | Order (int new_order)
| Set the order that this effect should be executed.
openshot::ClipBase * | ParentClip ()
| Parent clip object of this effect (which can be unparented and NULL).
void | ParentClip (openshot::ClipBase *new_clip)
| Set parent clip object of this effect.
std::string | ParentClipId () const
| Return the ID of this effect's parent clip.
virtual void | SetJson (int64_t requested_frame, const std::string value)
void | SetParentEffect (std::string parentEffect_id)
| Set the parent effect from which this properties will be set to.
virtual | ~EffectBase ()=default
Public Member Functions inherited from openshot::ClipBase
| ClipBase ()
| Constructor for the base clip.
float | Duration () const
| Get the length of this clip (in seconds).
virtual float | End () const
| Get end position (in seconds) of clip (trim end of video).
virtual void | End (float value)
| Set end position (in seconds) of clip (trim end of video).
virtual std::shared_ptr< openshot::Frame > | GetFrame (std::shared_ptr< openshot::Frame > frame, int64_t frame_number)=0
| This method is required for all derived classes of ClipBase, and returns a modified openshot::Frame object.
std::string | Id () const
| Get the Id of this clip object.
void | Id (std::string value)
int | Layer () const
| Get layer of clip on timeline (lower number is covered by higher numbers).
void | Layer (int value)
| Set layer of clip on timeline (lower number is covered by higher numbers).
bool | operator< (ClipBase &a)
bool | operator<= (ClipBase &a)
bool | operator> (ClipBase &a)
bool | operator>= (ClipBase &a)
virtual openshot::TimelineBase * | ParentTimeline ()
| Get the associated Timeline pointer (if any).
virtual void | ParentTimeline (openshot::TimelineBase *new_timeline)
| Set associated Timeline pointer.
float | Position () const
| Get position on timeline (in seconds).
void | Position (float value)
| Set position on timeline (in seconds).
float | Start () const
| Get start position (in seconds) of clip (trim start of video).
void | Start (float value)
| Set start position (in seconds) of clip (trim start of video).
virtual | ~ClipBase ()=default

## Public Attributes

Keyframe | amount
| Amount of sharpening to apply (0 to 2).
int | channel
| Channel to apply sharpening to (0 = All, 1 = Luma, 2 = Chroma).
int | mode
| Sharpening mode (0 = UnsharpMask, 1 = HighPassBlend).
Keyframe | radius
| Radius of the blur used in sharpening (0 to 10 pixels for 1080p).
Keyframe | threshold
| Threshold for applying sharpening (0 to 1).
Public Attributes inherited from openshot::EffectBase
EffectInfoStruct | info
| Information about the current effect.
EffectBase * | parentEffect
| Parent effect (which properties will set this effect properties).
std::map< int, std::shared_ptr< openshot::TrackedObjectBase > > | trackedObjects
| Map of Tracked Object's by their indices (used by Effects that track objects on clips).

## Additional Inherited Members

Protected Member Functions inherited from openshot::ClipBase
Json::Value | add_property_choice_json (std::string name, int value, int selected_value) const
| Generate JSON choice for a property (dropdown properties).
Json::Value | add_property_json (std::string name, float value, std::string type, std::string memo, const Keyframe *keyframe, float min_value, float max_value, bool readonly, int64_t requested_frame) const
| Generate JSON for a property.
Protected Attributes inherited from openshot::EffectBase
openshot::ClipBase * | clip
| Pointer to the parent clip instance (if any).
Protected Attributes inherited from openshot::ClipBase
float | end
| The position in seconds to end playing (used to trim the ending of a clip).
std::string | id
| ID Property for all derived Clip and Effect classes.
int | layer
| The layer this clip is on. Lower clips are covered up by higher clips.
float | position
| The position on the timeline where this clip should start playing.
std::string | previous_properties
| This string contains the previous JSON properties.
float | start
| The position in seconds to start playing (used to trim the beginning of a clip).
openshot::TimelineBase * | timeline
| Pointer to the parent timeline instance (if any).

## Detailed Description

This class provides a sharpen effect for video frames.

The sharpen effect enhances the edges and details in a video frame, making it appear sharper. It uses an unsharp mask or high-pass blend technique with adjustable parameters.

Definition at line 31 of file Sharpen.h.

## Constructor & Destructor Documentation

## Sharpen() [1/2]

Sharpen::Sharpen | ( |  | ) |

Default constructor.

Definition at line 24 of file Sharpen.cpp.

## Sharpen() [2/2]

Sharpen::Sharpen | ( | Keyframe | new_amount,
|  | Keyframe | new_radius,
|  | Keyframe | new_threshold )

Constructor with initial values.

Definition at line 35 of file Sharpen.cpp.

## Member Function Documentation

## GetFrame() [1/2]

std::shared_ptr< Frame > openshot::Sharpen::GetFrame | ( | int64_t | frame_number | ) |

inline override virtual

This method is required for all derived classes of ClipBase, and returns a new openshot::Frame object. All Clip keyframes and effects are resolved into pixels.

Returns
  A new openshot::Frame object

Parameters

  frame_number | The frame number (starting at 1) of the clip or effect on the timeline.

Implements openshot::ClipBase.

Definition at line 68 of file Sharpen.h.

## GetFrame() [2/2]

std::shared_ptr< Frame > Sharpen::GetFrame | ( | std::shared_ptr< Frame > | frame,
|  | int64_t | frame_number )

override

This method is required for all derived classes of EffectBase, and returns a modified openshot::Frame object.

The frame object is passed into this method, and a frame_number is passed in which tells the effect which settings to use from its keyframes (starting at 1).

Returns
  The modified openshot::Frame object

Parameters

  frame | The frame object that needs the effect applied to it
  frame_number | The frame number (starting at 1) of the effect on the timeline.

Definition at line 194 of file Sharpen.cpp.

Referenced by GetFrame().

## Json()

std::string Sharpen::Json | ( |  | ) | const

override virtual

Get and Set JSON methods.

Generate JSON string of this object

Reimplemented from openshot::EffectBase.

Definition at line 335 of file Sharpen.cpp.

## JsonValue()

Json::Value Sharpen::JsonValue | ( |  | ) | const

override virtual

Generate Json::Value for this object.

Reimplemented from openshot::EffectBase.

Definition at line 340 of file Sharpen.cpp.

Referenced by Json().

## PropertiesJSON()

std::string Sharpen::PropertiesJSON | ( | int64_t | requested_frame | ) | const

override virtual

Get all properties for a specific frame (perfect for a UI to display the current state of all properties at any time)

Implements openshot::ClipBase.

Definition at line 375 of file Sharpen.cpp.

## SetJson()

void Sharpen::SetJson | ( | const std::string | value | ) |

override virtual

Load JSON string into this object.

Reimplemented from openshot::EffectBase.

Definition at line 353 of file Sharpen.cpp.

## SetJsonValue()

void Sharpen::SetJsonValue | ( | const Json::Value | root | ) |

override virtual

Load Json::Value into this object.

Reimplemented from openshot::EffectBase.

Definition at line 359 of file Sharpen.cpp.

Referenced by SetJson().

## Member Data Documentation

## amount

Keyframe openshot::Sharpen::amount

Amount of sharpening to apply (0 to 2).

Definition at line 38 of file Sharpen.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), SetJsonValue(), Sharpen(), and Sharpen().

## channel

int openshot::Sharpen::channel

Channel to apply sharpening to (0 = All, 1 = Luma, 2 = Chroma).

Definition at line 50 of file Sharpen.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), SetJsonValue(), Sharpen(), and Sharpen().

## mode

int openshot::Sharpen::mode

Sharpening mode (0 = UnsharpMask, 1 = HighPassBlend).

Definition at line 47 of file Sharpen.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), SetJsonValue(), Sharpen(), and Sharpen().

## radius

Keyframe openshot::Sharpen::radius

Radius of the blur used in sharpening (0 to 10 pixels for 1080p).

Definition at line 41 of file Sharpen.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), SetJsonValue(), Sharpen(), and Sharpen().

## threshold

Keyframe openshot::Sharpen::threshold

Threshold for applying sharpening (0 to 1).

Definition at line 44 of file Sharpen.h.

Referenced by GetFrame(), JsonValue(), PropertiesJSON(), SetJsonValue(), Sharpen(), and Sharpen().

The documentation for this class was generated from the following files:

- effects/Sharpen.h
- effects/Sharpen.cpp